//
//  FlipImageViewController.m
//  FlipImage
//
//  Created by Deepak Kumar on 22/09/09.
//  Copyright Rose India 2009. All rights reserved.
//

#import "FlipImageViewController.h"
#define kImageHeight		200.0
#define kImageWidth			250.0
#define kTransitionDuration	0.75
#define kTopPlacement		80.0	

@implementation FlipImageViewController

@synthesize containerView, mainView, flipToView;

- (void)dealloc
{
	[mainView release];
	[flipToView release];
	[containerView release];
	
	[super dealloc];
}

- (void)viewDidLoad
{
	[super viewDidLoad];
	
	// create the container view which we will use for transition animation (centered horizontally)
	CGRect frame = CGRectMake(round((self.view.bounds.size.width - kImageWidth) / 2.0),
							  kTopPlacement, kImageWidth, kImageHeight);
	self.containerView = [[[UIView alloc] initWithFrame:frame] autorelease];
	[self.view addSubview:self.containerView];
	
	// create the initial image view
	frame = CGRectMake(0.0, 0.0, kImageWidth, kImageHeight);
	self.mainView = [[[UIImageView alloc] initWithFrame:frame] autorelease];
	self.mainView.image = [UIImage imageNamed:@"Screen.jpg"];
	[self.containerView addSubview:self.mainView];
	
	// create the alternate image view (to transition between)
	CGRect imageFrame = CGRectMake(0.0, 0.0, kImageWidth, kImageHeight);
	self.flipToView = [[[UIImageView alloc] initWithFrame:imageFrame] autorelease];
	self.flipToView.image = [UIImage imageNamed:@"Screen1.jpg"];
}
- (void)viewDidUnload
{
	[super viewDidUnload];
	
	self.containerView = nil;
	self.flipToView = nil;
	self.mainView = nil;
}

- (IBAction)flipAction:(id)sender
{
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:kTransitionDuration];
	
	[UIView setAnimationTransition:([self.mainView superview] ?
									UIViewAnimationTransitionFlipFromLeft : UIViewAnimationTransitionFlipFromRight)
						   forView:self.containerView cache:YES];
	if ([flipToView superview])
	{
		[self.flipToView removeFromSuperview];
		[self.containerView addSubview:mainView];
	}
	else
	{
		[self.mainView removeFromSuperview];
		[self.containerView addSubview:flipToView];
	}
	
	[UIView commitAnimations];
}

@end

